scim::Signal6< R, P1, P2, P3, P4, P5, P6, Marshal > Class Template Reference
SignalSlot

A template for a signal passing six arguments of type P1, P2, P3, P4, P5 and P6, and returning a value of type R. More...

`#include <scim_signals.h>`

## Public Types

typedef Slot6< R, P1, P2, P3, P4, P5, P6 > | SlotType
| Function signature for handlers connecting to the signal.

## Public Member Functions

Connection | connect (SlotType *slot)
SlotType * | slot ()
R | emit (P1 p1, P2 p2, P3 p3, P4 p4, P5 p5, P6 p6)
R | operator() (P1 p1, P2 p2, P3 p3, P4 p4, P5 p5, P6 p6)
| Function operator; calls emit().
Public Member Functions inherited from scim::Signal
| Signal ()
| Constructor.
virtual | ~Signal ()
| Destructor.
SlotNode * | connect (Slot *slot)
| Creates a new SlotNode for slot and adds it to the connection_list.

## Additional Inherited Members

Protected Types inherited from scim::Signal
typedef std::vector< Pointer< SlotNode > > | ConnectionList
| ConnectionList type.
Protected Attributes inherited from scim::Signal
ConnectionList | connection_list
| A list of all the slots connected to the signal.

## Detailed Description

template<typename R, typename P1, typename P2, typename P3, typename P4, typename P5, typename P6, typename Marshal = class DefaultMarshal<R>>
class scim::Signal6< R, P1, P2, P3, P4, P5, P6, Marshal >

A template for a signal passing six arguments of type P1, P2, P3, P4, P5 and P6, and returning a value of type R.

## Member Typedef Documentation

## SlotType

template<typename R, typename P1, typename P2, typename P3, typename P4, typename P5, typename P6, typename Marshal = class DefaultMarshal<R>>

typedef Slot6<R, P1, P2, P3, P4, P5, P6> scim::Signal6< R, P1, P2, P3, P4, P5, P6, Marshal >::SlotType

Function signature for handlers connecting to the signal.

## Member Function Documentation

## connect()

template<typename R, typename P1, typename P2, typename P3, typename P4, typename P5, typename P6, typename Marshal = class DefaultMarshal<R>>

Connection scim::Signal6< R, P1, P2, P3, P4, P5, P6, Marshal >::connect | ( | SlotType * | slot | ) |

inline

Connect a slot to the signal.

Parameters

  slot | - a slot of type Slot6<R, P1, P2, P3, P4, P5, P6>.

Returns
  a connection object.

The returned connection object can be used alter or change the connection.

References scim::Signal::connect(), and slot().

## slot()

template<typename R, typename P1, typename P2, typename P3, typename P4, typename P5, typename P6, typename Marshal = class DefaultMarshal<R>>

SlotType * scim::Signal6< R, P1, P2, P3, P4, P5, P6, Marshal >::slot | ( |  | ) |

inline

Returns a slot for this signal.

Returns
  a new slot of type Slot6<R, P1, P2, P3, P4, P5, P6>.

The returned slot can be passed to another signal allowing the other signal to call this signal when it gets emitted.

Referenced by connect(), and emit().

## emit()

template<typename R, typename P1, typename P2, typename P3, typename P4, typename P5, typename P6, typename Marshal = class DefaultMarshal<R>>

R scim::Signal6< R, P1, P2, P3, P4, P5, P6, Marshal >::emit | ( | P1 | p1,
|  | P2 | p2,
|  | P3 | p3,
|  | P4 | p4,
|  | P5 | p5,
|  | P6 | p6 )

inline

Emit the signal.

Parameters

  p1 | - passes p1 to the signal handler.
  p2 | - passes p2 to the signal handler.
  p3 | - passes p3 to the signal handler.
  p4 | - passes p4 to the signal handler.
  p5 | - passes p5 to the signal handler.
  p6 | - passes p6 to the signal handler.

Returns
  the value returned by the signal handler.

Calls every slot connected to this signal, in order of connection.

References scim::Signal::connection_list, and slot().

Referenced by operator()(), and scim::Signal6< void, P1, P2, P3, P4, P5, P6, IgnoreMarshal >::operator()().

## operator()()

template<typename R, typename P1, typename P2, typename P3, typename P4, typename P5, typename P6, typename Marshal = class DefaultMarshal<R>>

R scim::Signal6< R, P1, P2, P3, P4, P5, P6, Marshal >::operator() | ( | P1 | p1,
|  | P2 | p2,
|  | P3 | p3,
|  | P4 | p4,
|  | P5 | p5,
|  | P6 | p6 )

inline

Function operator; calls emit().

References emit().

The documentation for this class was generated from the following file:

- scim_signals.h